{*************************************************************}
{            Splash-screen sample for Delphi 32               }
{ Version:   1.00                                             }
{ Author:    Aleksey Kuznetsov                                }
{ E-Mail:    info@utilmind.com                                }
{ Homepage:  http://www.utilmind.com                          }
{ Created:   February, 21, 1999                               }
{ Modified:  February, 21, 1999                               }
{ Legal:     Copyright (c) 1999, UtilMind Solutions           }
{*************************************************************}
{   Splasher (English):                                       }
{ These sample program demonstrates display Splash-images     }
{ for the Windows-applications.                               }
{   Peculiarity of the given way:                             }
{ We create the very small program, purpose of which - to     }
{ display Splash image and Start the necessary Windows        }
{ application. The started program can not without fail have  }
{ extension .exe. For distract of the user attention,         }
{ it is possible to rename the main executable file to any    }
{ extension (for example: project1.exe - > project1.dll).     }
{   Sorry for terrible English :(                             }
{*************************************************************}
{   Splasher (Russian):                                       }
{     Splash-  }
{   Windows.                                     }
{     :                              }
{     ,   -  }
{            }
{ Windows.        }
{  .exe.    ,      }
{              }
{ (: project1.exe -> project1.dll).                   } 
{*************************************************************}
{ If at occurrence of any questions concerning these          }
{ sample program, please visit our website: www.utilmind.com  }
{*************************************************************}

program Splasher;

uses Windows;

{$R *.RES}
{$R SPLASH.RES}

const
  SplashWidth = 320;
  SplashHeight = 200;
  ProgramCaption = 'Splash demo';
  
var
  DesktopDC, MemDC:hDC;
  Bitmap: hBitmap;
  WindowClass: TWndClass;

type
  TSplash = class(TObject)
  private
    procedure Paint;
  public
    FDefWndProc: Pointer;
    FHandle: THandle;
    constructor Create;

    property DefWndProc: Pointer read FDefWndProc write FDefWndProc;
  end;

var
  Splash: TSplash;

function SplashWndProc(Window: HWND; Message, wParam, lParam: Longint): Longint; stdcall;
begin
  if Message = $F then Splash.Paint; { $F = wm_Paint message}
  Result := Windows.DefWindowProc(Window, Message, wParam, lParam);
end;

constructor TSplash.Create;
begin
  WindowClass.lpfnWndProc := @SplashWndProc;
  WindowClass.hCursor := LoadCursor(0, IDC_Wait);
  WindowClass.hbrBackground := 0;
  WindowClass.hInstance := hInstance;
  WindowClass.lpszClassName := 'XS';

  Windows.RegisterClass(WindowClass);

  FHandle := CreateWindowEx(ws_ex_ToolWindow, 'XS', '', ws_Popup or ws_Visible,
    GetSystemMetrics(sm_CXFullScreen) div 2 - SplashWidth div 2,
    GetSystemMetrics(sm_CYFullScreen) div 2 - SplashHeight div 2,
    SplashWidth, SplashHeight, 0, 0, HInstance, nil);

  Paint;  
end;

procedure TSplash.Paint;
begin
  DesktopDC := GetDC(FHandle);
  MemDC := CreateCompatibleDC(DeskTopDC);
  Bitmap := LoadBitmap(hInstance, 'SPLASH');
  SelectObject(MemDC, Bitmap);

  BitBlt(DesktopDC, 0, 0, SplashWidth, SplashHeight, MemDC, 0, 0, srcCopy);

  DeleteObject(Bitmap);
  DeleteObject(MemDC);
end;

Begin
  Splash := TSplash.Create;

  if WinExec('c:\MSOffice\WinWord\WinWord.exe splasher.dpr', SW_ShowNormal) < 32 then
   MessageBox(Splash.FHandle, 'File ''WinWord.exe'' not found.', ProgramCaption, mb_Ok or mb_IconStop);

  Splash.Free;
End.
