{-------------------------------------------------------------------------------}
{                                                                               }
{ Freeware. Please mail me if you use this, or have any suggestions.            }
{ hughdoar@hotmail.com                                                          }
{                                                                               }
{-------------------------------------------------------------------------------}

{
  demo for StringGrid, ListView and TreeView descendants. This allows you to set
  up an explorer like view of a denormalized result set
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Db, DBTables, Grids, hwdStringGrid, ComCtrls, hwdTreeView,
  hwdListView, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    DataSource1: TDataSource;
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Query1: TQuery;
    ComboBox1: TComboBox;
    hwdListView1: ThwdListView;
    Splitter3: TSplitter;
    hwdTreeView1: ThwdTreeView;
    hwdStringGrid1: ThwdStringGrid;
    hwdStringGrid2: ThwdStringGrid;
    Splitter4: TSplitter;
    Memo2: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  hwdTreeView1.Grid := hwdStringGrid1;
  hwdListView1.Grid := hwdStringGrid2;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Query1.Close;
  Query1.DatabaseName := ComboBox1.Text;
  Query1.Sql := Memo1.Lines;
  hwdStringGrid1.DataSource := DataSource1;
end;

procedure TForm1.FormCreate(Sender: TObject);
var sl :TStringList;
    i :Integer;
begin
  sl := TStringList.Create;
  try
    Session.GetAliasNames(sl);
    for i := 0 to sl.Count - 1 do
      ComboBox1.Items.Add(sl[i]);
  finally
    sl.Free;
  end;
  ComboBox1.ItemIndex := 0;
end;

end.
